import * as server_main from '@minecraft/server'

const action_display = {
    fadeInDuration: 0,
    stayDuration: 0,
    fadeOutDuration: 0
};

server_main.world.afterEvents.worldInitialize.subscribe((event) => {
    if (!server_main.world.scoreboard.getObjective('dimension_lotr')) {
        server_main.world.scoreboard.addObjective('dimension_lotr', 'Dimension')
    }
})

server_main.world.afterEvents.itemUse.subscribe((event) => {
    if (event.itemStack.typeId == "lotr:mordor_ring") {
        let dimensionObj = server_main.world.scoreboard.getObjective("dimension_lotr")
        let player = event.source
        let spawn_point_overworld = event.source.location

        if (dimensionObj) {
            if (player.dimension.id == "minecraft:overworld") {
                let tagStr = "dim_0:" + spawn_point_overworld.x + "|" + spawn_point_overworld.y + "|" + spawn_point_overworld.z;
                player.addTag(tagStr)
                let spawn_point_mordor = new server_main.Vector(7500, 80, 6000)
                //dimensionObj
                dimensionObj.setScore(player, 1)

                let structures_init = server_main.world.scoreboard.getObjective("initMordorMain")
                if (!structures_init) {
                    //ADD A MASK OVER UI + BEDROCK WALLS WHILE GENERATING STRUCTURES
                    player.addTag("initing_mordor");
                    let spawn_point_barad_dur = new server_main.Vector(7422, 61, 7587)
                    //server_main.world.getDimension("minecraft:the_end").runCommandAsync("tell @p Initializing Structure Spawners...")
                    player.runCommandAsync("/effect @s resistance 10 10 false");
                    player.teleport(spawn_point_barad_dur, {
                        dimension: server_main.world.getDimension("minecraft:the_end")
                    });
                    //START
                    server_main.system.runTimeout(() => {
                        player.runCommandAsync("structure load mystructure:barad_dur_structL 7423 58 7587 180_degrees")
                        server_main.system.runTimeout(() => {
                            player.runCommandAsync("setblock 7422 60 7587 bedrock");
                            player.runCommandAsync("setblock 7422 63 7587 bedrock");

                            player.runCommandAsync("setblock 7421 61 7587 bedrock");
                            player.runCommandAsync("setblock 7423 61 7587 bedrock");
                            player.runCommandAsync("setblock 7421 62 7587 bedrock");
                            player.runCommandAsync("setblock 7423 62 7587 bedrock");
                            player.runCommandAsync("setblock 7422 61 7586 bedrock");
                            player.runCommandAsync("setblock 7422 61 7588 bedrock");
                            player.runCommandAsync("setblock 7422 62 7586 bedrock");
                            player.runCommandAsync("setblock 7422 62 7588 bedrock");
                            server_main.system.runTimeout(() => {
                                player.runCommandAsync("setblock 7423 57 7587 redstone_block");
                                server_main.system.runTimeout(() => {
                                    player.teleport(spawn_point_mordor, {
                                        dimension: server_main.world.getDimension("minecraft:the_end")
                                    });
                                    player.runCommandAsync("tag @p remove initing_mordor");
                                    server_main.world.scoreboard.addObjective('initMordorMain', 'Mordor_Init')
                                    player.runCommandAsync("effect @s resistance 1 1 false");
                                    server_main.system.runTimeout(() => {                                   
                                        player.runCommandAsync("title @s actionbar Mordor Complete!'") ;
                                    }, 5)
                                }, 50)
                            }, 200)
                        }, 60)
                    }, 20)
                }
                else {
                    player.teleport(spawn_point_mordor, {
                        dimension: server_main.world.getDimension("minecraft:the_end")
                    });
                }
            }
            else {
                //let tagStr = "dim_0:" + spawn_point_overworld.x.ToString() + "|" + spawn_point_overworld.y.ToString() + "|" +  spawn_point_overworld.z.ToString();
                let tags = player.getTags()
                var locationPOS = new server_main.Vector(0, 0, 0)
                for (const tag of tags) {
                    if (tag.startsWith("dim_0:", 0)) {
                        let locationTag = tag.slice(6)
                        let locationVals = locationTag.split("|")
                        locationPOS.x = parseInt(locationVals[0])
                        locationPOS.y = parseInt(locationVals[1])
                        locationPOS.z = parseInt(locationVals[2])
                    }
                }

                dimensionObj.setScore(player, 0)
                player.teleport(locationPOS, {
                    dimension: server_main.world.getDimension("minecraft:overworld"),
                });
                //player.runCommandAsync("/effect @s slow_falling 10 1000 false")
            }
        }
        else {
            player.runCommandAsync("tell @s Scoreboard Dimensions Not Initialized...")
        }

    }
})

